<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'national_id',
        'email',
        'phone',
        'address',
        'group_id',
        'role_id',
        'password',
        'profile_picture',
    ];


    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'password' => 'hashed',
    ];


    // app/Models/User.php
            static public function getUser($id){
        return User::find($id);
    }
        public function role()
        {
            return $this->belongsTo(Role::class, 'role_id');
        }

        public function group()
        {
            return $this->belongsTo(Group::class, 'group_id');
        }

            public function roles()
        {
            return $this->belongsToMany(Role::class, 'role_user');
        }

        public function hasRole($roleName)
        {
            return $this->roles->contains('name', $roleName);
        }

    public function permissions()
    {
        return $this->belongsToMany(Permission::class, 'permission_user', 'user_id', 'permission_id');
    }

    public function details()
    {
        return $this->hasOne(UserDetail::class, 'userCode', 'id');
    }

}
